'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports DotNetNuke
Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Entities.Modules.Actions
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Modules.Announcements.Components.Templating

Namespace Components.BaseClasses
    Public Class AnnouncementsBase
        Inherits PortalModuleBase

        Private m_Template As Template

        Protected ReadOnly Property WorkflowId As Integer
            Get
                Return Workflow.WorkflowSettingsController.GetWorkflow(ModuleId, TabId, PortalId).Value
            End Get
        End Property


        Protected ReadOnly Property Template() As Template
            Get
                Dim m_TemplateCachKey As String = "dnnAnnouncements_Template_" + Me.TabModuleId.ToString
                If m_Template Is Nothing Then
                    Dim obj As Object = DataCache.GetCache(m_TemplateCachKey)
                    If obj Is Nothing Then
                        obj = New Template(ModuleId, TabModuleId, Settings)
                        DataCache.SetCache(m_TemplateCachKey, obj)
                    End If
                    m_Template = CType(obj, Template)
                End If
                Return m_Template
            End Get
        End Property


        Protected ReadOnly Property editEnabled() As Boolean
            Get
                Dim blnPreview As Boolean = (PortalSettings.UserMode = Entities.Portals.PortalSettings.Mode.View)
                Return (Not blnPreview) AndAlso Security.PortalSecurity.HasNecessaryPermission(Security.SecurityAccessLevel.Edit, PortalSettings, Me.ModuleConfiguration, UserInfo)

            End Get
        End Property


        Private _Dispatcher As Dispatcher = Nothing
        Public Property Dispatcher() As Dispatcher
            Get
                Return _Dispatcher
            End Get
            Set(ByVal value As Dispatcher)
                _Dispatcher = value
            End Set
        End Property

        Private _objModules As Entities.Modules.ModuleController
        Protected ReadOnly Property objModules() As Entities.Modules.ModuleController
            Get
                If _objModules Is Nothing Then
                    _objModules = New Entities.Modules.ModuleController
                End If
                Return _objModules
            End Get
        End Property

        Protected Sub AddModuleMessage(ByVal message As String, ByVal MessageType As Skins.Controls.ModuleMessage.ModuleMessageType)
            If Dispatcher Is Nothing Then
                DotNetNuke.UI.Skins.Skin.AddModuleMessage(Me, message, MessageType)
            Else
                Dispatcher.AddMessage(message, MessageType)
            End If

        End Sub


    End Class
End Namespace