'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2009
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports DotNetNuke

Namespace Components.Data
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The DataProvider Class Is an abstract class that provides the DataLayer
    ''' for the Announcments Module.
    ''' </summary>
    ''' <history>
    ''' 	[cnurse]	9/20/2004	Moved Announcements to a separate Project
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public MustInherit Class DataProvider

#Region "Shared/Static Methods"

        ' singleton reference to the instantiated object 
        Private Shared objProvider As DataProvider = Nothing

        ' constructor
        Shared Sub New()
            CreateProvider()
        End Sub

        ' dynamically create provider
        Private Shared Sub CreateProvider()
            objProvider = CType(Framework.Reflection.CreateObject("data", "DotNetNuke.Modules.Announcements.Components.Data", ""), DataProvider)
        End Sub

        ' return the provider
        Public Shared Shadows Function Instance() As DataProvider
            Return objProvider
        End Function

#End Region

#Region "Abstract methods"

        Public MustOverride Function Add(ByVal ModuleId As Integer, ByVal ParentItemId As Integer, ByVal StateID As Integer, ByVal IsPublished As Boolean, ByVal Title As String, ByVal Description As String, ByVal Summary As String, ByVal imageSource As String, ByVal URL As String, ByVal PublishDate As DateTime, ByVal ExpireDate As DateTime, ByVal ViewOrder As Integer, ByVal CreatedByUserId As Integer, ByVal CreatedOnDate As DateTime) As Integer
        Public MustOverride Function [Get](ByVal ItemId As Integer, ByVal ModuleId As Integer) As IDataReader
        Public MustOverride Function GetAll(ByVal ModuleId As Integer, ByVal StartDate As Date, ByVal EndDate As Date) As IDataReader
        Public MustOverride Function GetAllVersions(ByVal ModuleId As Integer, ByVal ItemId As Integer) As IDataReader
        Public MustOverride Function GetPendingOnUser(ByVal UserId As Integer) As IDataReader
        Public MustOverride Function GetCurrent(ByVal ModuleId As Integer, ByVal StartDate As Date, ByVal IsPublished As Boolean) As IDataReader
        Public MustOverride Function GetExpired(ByVal ModuleId As Integer) As IDataReader
        Public MustOverride Function GetTop(ByVal ModuleID As Integer, ByVal IsPublished As Boolean, ByVal ParentItemId As Integer) As IDataReader
        Public MustOverride Sub Update(ByVal ItemId As Integer, ByVal ModuleId As Integer, ByVal StateID As Integer, ByVal IsPublished As Boolean, ByVal Title As String, ByVal Description As String, ByVal Summary As String, ByVal imageSource As String, ByVal URL As String, ByVal PublishDate As DateTime, ByVal ExpireDate As DateTime, ByVal ViewOrder As Integer, ByVal LastModifiedByUserId As Integer, ByVal LastModifiedOnDate As DateTime)
        Public MustOverride Sub Delete(ByVal ModuleID As Integer, ByVal ItemID As Integer)
        Public MustOverride Sub DeleteAnnouncementUsers()

#End Region

    End Class
End Namespace