'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2008
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports DotNetNuke


Namespace DotNetNuke.Modules.Documents

  ''' -----------------------------------------------------------------------------
  ''' <summary>
  ''' The DocumentInfo Class provides the Documents Business Object
  ''' </summary>
  ''' <remarks>
  ''' </remarks>
  ''' <history>
  ''' 	[cnurse]	9/22/2004	Moved Documents to a separate Project
  ''' </history>
  ''' -----------------------------------------------------------------------------
  Public Class DocumentInfo

#Region "Private Members"

        Private _ItemId As Integer
        Private _ModuleId As Integer
    'Private _CreatedByUser As String
    Private _CreatedByUserID As Integer
        Private _CreatedDate As Date
        Private _Url As String
        Private _Title As String
        Private _Category As String
        Private _Size As Integer
        Private _ContentType As String
        Private _TrackClicks As Boolean
        Private _clicks As Integer
        Private _NewWindow As Boolean
    Private _OwnedByUserID As Integer
    Private _ModifiedByUserID As Integer
    Private _ModifiedDate As DateTime
    Private _SortOrderIndex As Integer
    Private _Description As String

    Private _OwnedByUser As String
    Private _ModifiedByUser As String
    Private _CreatedByUser As String

#End Region

#Region "Contructors"

    Public Sub New()
    End Sub

#End Region

#Region "Properties"

        ' public properties
        Public Property ItemId() As Integer
            Get
                Return _ItemId
            End Get
            Set(ByVal Value As Integer)
                _ItemId = Value
            End Set
        End Property

        Public Property ModuleId() As Integer
            Get
                Return _ModuleId
            End Get
            Set(ByVal Value As Integer)
                _ModuleId = Value
            End Set
        End Property

    'Public Property CreatedByUser() As String
    '    Get
    '        Return _CreatedByUser
    '    End Get
    '    Set(ByVal Value As String)
    '        _CreatedByUser = Value
    '    End Set
    'End Property
    Public Property CreatedByUserID() As Integer
      Get
        Return _CreatedByUserID
      End Get
      Set(ByVal Value As Integer)
        _CreatedByUserID = Value
      End Set
    End Property

    Public Property CreatedByUser() As String
      Get
        Return _CreatedByUser
      End Get
      Set(ByVal Value As String)
        _CreatedByUser = Value
      End Set

    End Property

    Public Property CreatedDate() As Date
      Get
        Return _CreatedDate
      End Get
      Set(ByVal Value As Date)
        _CreatedDate = Value
      End Set
    End Property

    Public Property Url() As String
      Get
        Return _Url
      End Get
      Set(ByVal Value As String)
        _Url = Value
      End Set
    End Property

    Public Property Title() As String
      Get
        Return _Title
      End Get
      Set(ByVal Value As String)
        _Title = Value
      End Set
    End Property

    Public Property Category() As String
      Get
        Return _Category
      End Get
      Set(ByVal Value As String)
        _Category = Value
      End Set
    End Property

    Public Property Size() As Integer
      Get
        Return _Size
      End Get
      Set(ByVal Value As Integer)
        _Size = Value
      End Set
    End Property

    Public Property ContentType() As String
      Get
        Return _ContentType
      End Get
      Set(ByVal Value As String)
        _ContentType = Value
      End Set
    End Property

    Public Property TrackClicks() As Boolean
      Get
        Return _TrackClicks
      End Get
      Set(ByVal Value As Boolean)
        _TrackClicks = Value
      End Set
    End Property

    Public Property NewWindow() As Boolean
      Get
        Return _NewWindow
      End Get
      Set(ByVal Value As Boolean)
        _NewWindow = Value
      End Set
    End Property

    Public Property OwnedByUserID() As Integer
      Get
        Return _OwnedByUserID
      End Get
      Set(ByVal Value As Integer)
        _OwnedByUserID = Value
      End Set
    End Property

Public Property Clicks() As Integer
      Get
        If _clicks < 0 Then
          Return 0
        Else
          Return _clicks
        End If

      End Get
      Set(ByVal Value As Integer)
        _clicks = Value
      End Set
    End Property

    Public Property ModifiedByUserID() As Integer
      Get
        Return _ModifiedByUserID
      End Get
      Set(ByVal Value As Integer)
        _ModifiedByUserID = Value
      End Set
    End Property

    Public Property ModifiedDate() As DateTime
      Get
        Return _ModifiedDate
      End Get
      Set(ByVal Value As DateTime)
        _ModifiedDate = Value
      End Set
    End Property

    Public Property SortOrderIndex() As Integer
      Get
        Return _SortOrderIndex
      End Get
      Set(ByVal Value As Integer)
        _SortOrderIndex = Value
      End Set
    End Property

    Public Property Description() As String
      Get
        Return _Description
      End Get
      Set(ByVal Value As String)
        _Description = Value
      End Set
    End Property

    Public Property OwnedByUser() As String
      Get
        Return _OwnedByUser
      End Get
      Set(ByVal Value As String)
        _OwnedByUser = Value
      End Set
    End Property

    Public Property ModifiedByUser() As String
      Get
        Return _ModifiedByUser
      End Get
      Set(ByVal Value As String)
        _ModifiedByUser = Value
      End Set
        End Property

        Public Property StateID As Integer = Null.NullInteger
        Public Property StateName As String
        Public Property Version As Integer = Null.NullInteger
        Public Property IsPublished As Boolean = False
        Public Property ParentItemId As Integer = Null.NullInteger
        Public Property WorkflowId As Integer = Null.NullInteger
        Public Property WorkflowName As String
        Public Property Comment As String = String.Empty
        Public Property Notify As Boolean = False
        Public Property Approved As Boolean = True

    Public ReadOnly Property FormatSize() As String
      Get
        Try
          If Not Common.Utilities.Null.IsNull(Size) Then
            If Size > (1024 * 1024) Then
              Return Format(Size / (1024 * 1024), "#,##0.00 MB")
            Else
              Return Format(Size / 1024, "#,##0.00 KB")
            End If
          Else
            Return Localization.GetString("Unknown")
          End If
        Catch exc As Exception
          Return Localization.GetString("Unknown")
        End Try
      End Get
    End Property

#End Region

  End Class

End Namespace
