'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2010
' by DotNetNuke Corporation
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports DotNetNuke.Entities

Namespace DotNetNuke.Modules.Html

    ''' -----------------------------------------------------------------------------
    ''' Namespace:  DotNetNuke.Modules.Html
    ''' Project:    DotNetNuke
    ''' Class:      HtmlTextInfo
    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' Defines an instance of an HtmlText object
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Class HtmlTextInfo
        Inherits BaseEntityInfo

        ' local property declarations
        Private _ItemID As Integer = -1
        Private _ModuleID As Integer
        Private _Content As String
        Private _Version As Integer
        Private _WorkflowID As Integer
        Private _WorkflowName As String
        Private _StateID As Integer
        Private _StateName As String
        Private _IsPublished As Boolean = False
        Private _PortalID As Integer
        Private _Notify As Boolean = False
        Private _IsActive As Boolean = True
        Private _Comment As String = ""
        Private _Approved As Boolean = True
        Private _DisplayName As String
        Private _groupUID As Guid
        Private _parentUID As Guid
        Private _groupTitle As String
        Private _childTabCount As Integer

        ' initialization
        Public Sub New()
        End Sub

        ' public properties
        Public Property ItemID() As Integer
            Get
                Return _ItemID
            End Get
            Set(ByVal Value As Integer)
                _ItemID = Value
            End Set
        End Property

        Public Property ModuleID() As Integer
            Get
                Return _ModuleID
            End Get
            Set(ByVal Value As Integer)
                _ModuleID = Value
            End Set
        End Property

        Public Property Content() As String
            Get
                Return _Content
            End Get
            Set(ByVal Value As String)
                _Content = Value
            End Set
        End Property

        Public Property Version() As Integer
            Get
                Return _Version
            End Get
            Set(ByVal Value As Integer)
                _Version = Value
            End Set
        End Property

        Public Property WorkflowID() As Integer
            Get
                Return _WorkflowID
            End Get
            Set(ByVal Value As Integer)
                _WorkflowID = Value
            End Set
        End Property

        Public Property WorkflowName() As String
            Get
                Return _WorkflowName
            End Get
            Set(ByVal Value As String)
                _WorkflowName = Value
            End Set
        End Property

        Public Property StateID() As Integer
            Get
                Return _StateID
            End Get
            Set(ByVal Value As Integer)
                _StateID = Value
            End Set
        End Property

        Public Property StateName() As String
            Get
                Return _StateName
            End Get
            Set(ByVal Value As String)
                _StateName = Value
            End Set
        End Property

        Public Property IsPublished() As Boolean
            Get
                Return _IsPublished
            End Get
            Set(ByVal Value As Boolean)
                _IsPublished = Value
            End Set
        End Property

        Public Property PortalID() As Integer
            Get
                Return _PortalID
            End Get
            Set(ByVal Value As Integer)
                _PortalID = Value
            End Set
        End Property

        Public Property Notify() As Boolean
            Get
                Return _Notify
            End Get
            Set(ByVal Value As Boolean)
                _Notify = Value
            End Set
        End Property

        Public Property IsActive() As Boolean
            Get
                Return _IsActive
            End Get
            Set(ByVal Value As Boolean)
                _IsActive = Value
            End Set
        End Property

        Public Property Comment() As String
            Get
                Return _Comment
            End Get
            Set(ByVal Value As String)
                _Comment = Value
            End Set
        End Property

        Public Property Approved() As Boolean
            Get
                Return _Approved
            End Get
            Set(ByVal Value As Boolean)
                _Approved = Value
            End Set
        End Property

        Public Property DisplayName() As String
            Get
                Return _DisplayName
            End Get
            Set(ByVal Value As String)
                _DisplayName = Value
            End Set
        End Property

        Public Property GroupTitle() As String
            Get
                Return Me._groupTitle
            End Get
            Set(ByVal Value As String)
                Me._groupTitle = Value
            End Set
        End Property

        Public Property GroupUID() As Guid
            Get
                Return Me._groupUID
            End Get
            Set(ByVal Value As Guid)
                Me._groupUID = Value
            End Set
        End Property

        Public Property ParentUID() As Guid
            Get
                Return Me._parentUID
            End Get
            Set(ByVal Value As Guid)
                Me._parentUID = Value
            End Set
        End Property

        Public Property ChildTabCount() As Integer
            Get
                Return Me._childTabCount
            End Get
            Set(ByVal value As Integer)
                Me._childTabCount = value
            End Set
        End Property
    End Class

End Namespace

